MavenPublication (Gradle API 2.14.1)

org.gradle.api.publish.maven

## Interface MavenPublication

- All Superinterfaces:
    Named, Publication

      @Incubating
      public interface MavenPublication
      extends Publication

  A `MavenPublication` is the representation/configuration of how Gradle should publish something in Maven format. You directly add a named Maven Publication the project's `publishing.publications` container by providing `MavenPublication` as the type.

       publishing {
         publications {
           myPublicationName(MavenPublication) {
             // Configure the publication here
           }
         }
       }

  The default Maven POM identifying attributes are mapped as follows:
  - `groupId` - `project.group`
  - `artifactId` - `project.name`
  - `version` - `project.version`

  For certain common use cases, it's often sufficient to specify the component to publish, and nothing more (`from(org.gradle.api.component.SoftwareComponent)`. The published component is used to determine which artifacts to publish, and which dependencies should be listed in the generated POM file.

  To add additional artifacts to the set published, use the `artifact(Object)` and `artifact(Object, org.gradle.api.Action)` methods. You can also completely replace the set of published artifacts using `setArtifacts(Iterable)`. Together, these methods give you full control over what artifacts will be published.

  For any other tweaks to the publication, it is possible to modify the generated POM prior to publication. This is done using the `MavenPom.withXml(org.gradle.api.Action)` method of the POM returned via the `getPom()` method, or directly by an action (or closure) passed into `pom(org.gradle.api.Action)`.

  #### Example of publishing a java module with a source artifact and custom POM description

       apply plugin: "java"
       apply plugin: "maven-publish"

       task sourceJar(type: Jar) {
         from sourceSets.main.allJava
         classifier "sources"
       }

       publishing {
         publications {
           myPublication(MavenPublication) {
             from components.java
             artifact sourceJar
             pom.withXml {
               asNode().appendNode('description', 'A demonstration of Maven POM customization')
             }
           }
         }
       }

  Since:
    1.4

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Named

      `Named.Namer`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `MavenArtifact` | `artifact(Object source)` Creates a custom `MavenArtifact` to be included in the publication.
    `MavenArtifact` | `artifact(Object source, Action<? super MavenArtifact> config)` Creates an `MavenArtifact` to be included in the publication, which is configured by the associated action.
    `void` | `from(SoftwareComponent component)` Provides the software component that should be published.
    `String` | `getArtifactId()` Returns the artifactId for this publication.
    `MavenArtifactSet` | `getArtifacts()` Returns the complete set of artifacts for this publication.
    `String` | `getGroupId()` Returns the groupId for this publication.
    `MavenPom` | `getPom()` The POM that will be published.
    `String` | `getVersion()` Returns the version for this publication.
    `void` | `pom(Action<? super MavenPom> configure)` Configures the POM that will be published.
    `void` | `setArtifactId(String artifactId)` Sets the artifactId for this publication.
    `void` | `setArtifacts(Iterable<?> sources)` Clears any previously added artifacts from `getArtifacts()` and creates artifacts from the specified sources.
    `void` | `setGroupId(String groupId)` Sets the groupId for this publication.
    `void` | `setVersion(String version)` Sets the version for this publication.

    - ### Methods inherited from interface org.gradle.api.Named

      `getName`

- - ### Method Detail

    - #### getPom

          MavenPom getPom()

      The POM that will be published.
      Returns:
        The POM that will be published.

    - #### pom

          void pom(Action<? super MavenPom> configure)

      Configures the POM that will be published. The supplied action will be executed against the `getPom()` result. This method also accepts a closure argument, by type coercion.
      Parameters:
        `configure` - The configuration action.

    - #### from

          void from(SoftwareComponent component)

      Provides the software component that should be published.
      - Any artifacts declared by the component will be included in the publication.
      - The dependencies declared by the component will be included in the published meta-data.
      Currently 2 types of component are supported: 'components.java' (added by the JavaPlugin) and 'components.web' (added by the WarPlugin). For any individual MavenPublication, only a single component can be provided in this way. The following example demonstrates how to publish the 'java' component to a Maven repository.

           apply plugin: "java"
           apply plugin: "maven-publish"

           publishing {
             publications {
               maven(MavenPublication) {
                 from components.java
               }
             }
           }

      Parameters:
        `component` - The software component to publish.

    - #### artifact

          MavenArtifact artifact(Object source)

      Creates a custom `MavenArtifact` to be included in the publication. The `artifact` method can take a variety of input:
      - A `PublishArtifact` instance. Extension and classifier values are taken from the wrapped instance.
      - An `AbstractArchiveTask` instance. Extension and classifier values are taken from the wrapped instance.
      - Anything that can be resolved to a `File` via the `Project.file(Object)` method. Extension and classifier values are interpolated from the file name.
      - A `Map` that contains a 'source' entry that can be resolved as any of the other input types, including file. This map can contain a 'classifier' and an 'extension' entry to further configure the constructed artifact.
      The following example demonstrates the addition of various custom artifacts.

           apply plugin: "maven-publish"

           task sourceJar(type: Jar) {
             classifier "sources"
           }

           publishing {
             publications {
               maven(MavenPublication) {
                 artifact sourceJar // Publish the output of the sourceJar task
                 artifact 'my-file-name.jar' // Publish a file created outside of the build
                 artifact source: sourceJar, classifier: 'src', extension: 'zip'
               }
             }
           }

      Parameters:
        `source` - The source of the artifact content.

    - #### artifact

          MavenArtifact artifact(Object source,
                               Action<? super MavenArtifact> config)

      Creates an `MavenArtifact` to be included in the publication, which is configured by the associated action. The first parameter is used to create a custom artifact and add it to the publication, as per `artifact(Object)`. The created `MavenArtifact` is then configured using the supplied action, which can override the extension or classifier of the artifact. This method also accepts the configure action as a closure argument, by type coercion.

           apply plugin: "maven-publish"

           task sourceJar(type: Jar) {
             classifier "sources"
           }

           publishing {
             publications {
               maven(MavenPublication) {
                 artifact(sourceJar) {
                   // These values will be used instead of the values from the task. The task values will not be updated.
                   classifier "src"
                   extension "zip"
                 }
                 artifact("my-docs-file.htm") {
                   classifier "documentation"
                   extension "html"
                 }
               }
             }
           }

      Parameters:
        `source` - The source of the artifact.
        `config` - An action to configure the values of the constructed `MavenArtifact`.

    - #### setArtifacts

          void setArtifacts(Iterable<?> sources)

      Clears any previously added artifacts from `getArtifacts()` and creates artifacts from the specified sources. Each supplied source is interpreted as per `artifact(Object)`. For example, to exclude the dependencies declared by a component and instead use a custom set of artifacts:

           apply plugin: "java"
           apply plugin: "maven-publish"

           task sourceJar(type: Jar) {
             classifier "sources"
           }

           publishing {
             publications {
               maven(MavenPublication) {
                 from components.java
                 artifacts = ["my-custom-jar.jar", sourceJar]
               }
             }
           }

      Parameters:
        `sources` - The set of artifacts for this publication.

    - #### getArtifacts

          MavenArtifactSet getArtifacts()

      Returns the complete set of artifacts for this publication.
      Returns:
        the artifacts.

    - #### getGroupId

          String getGroupId()

      Returns the groupId for this publication.

    - #### setGroupId

          void setGroupId(String groupId)

      Sets the groupId for this publication.

    - #### getArtifactId

          String getArtifactId()

      Returns the artifactId for this publication.

    - #### setArtifactId

          void setArtifactId(String artifactId)

      Sets the artifactId for this publication.

    - #### getVersion

          String getVersion()

      Returns the version for this publication.

    - #### setVersion

          void setVersion(String version)

      Sets the version for this publication.